﻿/*
 * Created by SharpDevelop.
 * User: jt
 * Date: 30-01-2011
 * Time: 14:53
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Net;
using System.Globalization;
using System.Text;
using System.IO;
using System.Web;
using System.Reflection;
using System.Drawing;
using System.Windows.Forms;

namespace HovText
{
	/// <summary>
	/// Description of FeedbackForm.
	/// </summary>
	public partial class FeedbackForm : Form
	{
		public FeedbackForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();

			this.Text = "Feedback".GT();
			foreach (Control ctl in this.Controls)
				if (ctl is Label ||
				    ctl is Button ||
				    ctl is CheckBox)
				ctl.Text = ctl.Text.GT();
			checkBoxTranslations.Visible = checkBoxTranslations.Checked = File.Exists("hovlang.txt");
				
			DoCheckWebsite();
		}
		
		enum ServerState { Unknown, OK, Down};
		ServerState state = ServerState.Unknown;
		
		private void DoCheckWebsite()
		{
			new System.Threading.Thread (ChkThread).Start();
			System.Windows.Forms.Timer tm = new System.Windows.Forms.Timer();
			tm.Interval = 500;
			tm.Tick += delegate 
				{ 
				if (state != ServerState.Unknown)
				{ 
					tm.Enabled  = false;
					if (state == ServerState.Down)
						MessageBox.Show("Cannot connect to HovText server, you will not be able to send your message".GT(),
						                "HovText - " +"Warning".GT(), MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				};
				};
			tm.Enabled = true;
		}

		string serverVersion = null;
		private void ChkThread()
		{
			try
			{
				HttpWebRequest req = (HttpWebRequest)WebRequest.Create("http://hovtext.com");
				req.UserAgent = "HovText " + VersionInfo.Instance.GetString();
				HttpWebResponse reply = (HttpWebResponse)req.GetResponse();
				if (reply.StatusCode== HttpStatusCode.OK)
					state = ServerState.OK;
				else
					state = ServerState.Down;
			    serverVersion = new StreamReader(reply.GetResponseStream()).ReadToEnd();			
			} catch 
			{
				state = ServerState.Down;
			}
		}

		
		Nullable<bool> send =null;		
		void ButtonSendClick(object sender, EventArgs e)
		{
			buttonSend.Enabled = false;
			new System.Threading.Thread (SendFeedback).Start();
			System.Windows.Forms.Timer tm = new System.Windows.Forms.Timer();
			tm.Interval = 500;
			tm.Tick += delegate 
			{ 
				if (send != null)
				{ 
					tm.Enabled  = false;
					if (! (bool)send)
						MessageBox.Show("Cannot connect to HovText-server, your message was not send.".GT(),
						                "HovText - " +"Error".GT(), MessageBoxButtons.OK, MessageBoxIcon.Error);
					else {
						MessageBox.Show("Thank you for your feedback".GT(),
						                "HovText - " +"Feedback".GT(), MessageBoxButtons.OK);
					}
					buttonSend.Enabled = true;
					Close();
				}
			};	
			tm.Enabled = true;
		}
		
		void SendFeedback()
		{
			try
			{
				
				string ver = VersionInfo.Instance.GetString();
				UTF8Encoding enc=new UTF8Encoding();
				string postData="email="+textBoxEmail.Text;
				postData += ("&comment="+ HttpUtility.UrlEncode(textBoxMessage.Text));
				postData += ("&version="+ver);
				if (checkBoxTranslations.Checked)
				{
					string transstr= File.ReadAllText("hovlang.txt");
					postData += ("&translation="+HttpUtility.UrlEncode(transstr));
				}
				
				byte[]  data = enc.GetBytes(postData);

				
				HttpWebRequest req = (HttpWebRequest)WebRequest.Create("http://hovtext.com/feedback_registre.php");
				req.UserAgent = "HovText " + ver;
				req.Method ="POST";
				req.ContentLength = data.Length;
				req.ContentType = "application/x-www-form-urlencoded";

				Stream postStream = req.GetRequestStream();
				postStream.Write(data, 0, data.Length);
				postStream.Close();

				HttpWebResponse reply = (HttpWebResponse)req.GetResponse();
				if (reply.StatusCode== HttpStatusCode.OK)
					send =true;
				else
					state = ServerState.Down;
			    serverVersion = new StreamReader(reply.GetResponseStream()).ReadToEnd();			
			} catch (Exception ex)
			{
				DbgLog.Instance.Log("Error sending feedback:" + ex.ToString());
				send =false;
			}

		}
		
		void TextBoxMessageTextChanged(object sender, EventArgs e)
		{
			buttonSend.Enabled = textBoxMessage.TextLength >0;
		}
	}
}
